/*
	Copyright (c) 2013-2019 EasyDarwin.ORG.  All rights reserved.
	Github: https://github.com/EasyDarwin
	WEChat: EasyDarwin
	Website: http://www.easydarwin.org
*/
#ifndef __EasyPusher_H__
#define __EasyPusher_H__

#include "EasyTypes.h"

#define RTSP_CLIENT_NAME	"EasyPusher v2.0.19.0415"

typedef struct __EASY_AV_Frame
{
    Easy_U32    u32AVFrameFlag;		/* ֡־  Ƶ or Ƶ */
    Easy_U32    u32AVFrameLen;		/* ֡ĳ */
    Easy_U32    u32VFrameType;		/* ƵͣI֡P֡ */
    Easy_U8     *pBuffer;			/*  */
	Easy_U32	u32TimestampSec;	/* ʱ()*/
	Easy_U32	u32TimestampUsec;	/* ʱ(΢) */
}EASY_AV_Frame;

/* ¼Ͷ */
typedef enum __EASY_PUSH_STATE_T
{
    EASY_PUSH_STATE_CONNECTING   =   1,     /*  */
    EASY_PUSH_STATE_CONNECTED,              /* ӳɹ */
    EASY_PUSH_STATE_CONNECT_FAILED,         /* ʧ */
    EASY_PUSH_STATE_CONNECT_ABORT,          /* 쳣ж */
    EASY_PUSH_STATE_PUSHING,                /*  */
    EASY_PUSH_STATE_DISCONNECTED,           /* Ͽ */
    EASY_PUSH_STATE_ERROR
}EASY_PUSH_STATE_T;

/* ͻص _userptrʾûԶ */
typedef int (*EasyPusher_Callback)(int _id, EASY_PUSH_STATE_T _state, EASY_AV_Frame *_frame, void *_userptr);

#ifdef __cplusplus
extern "C"
{
#endif

	/* ;  Ϊֵ */
	Easy_API Easy_Handle Easy_APICALL EasyPusher_Create();
	
	/* ͷ; */
	Easy_API Easy_U32 Easy_APICALL EasyPusher_Release(Easy_Handle handle);

    /* ¼ص userptrԶָ*/
    Easy_API Easy_U32 Easy_APICALL EasyPusher_SetEventCallback(Easy_Handle handle,  EasyPusher_Callback callback, int id, void *userptr);

	/* ʼ serverAddr:ýַport:ý˿ڡstreamName:<xxx.sdp>username/password:Яû롢pstruStreamInfo:͵ý嶨塢bufferKSize:kΪλĻС<512~2048֮,Ĭ512> bool createlogfile:־ļ*/
	Easy_API Easy_U32 Easy_APICALL EasyPusher_StartStream(Easy_Handle handle, char* serverAddr, Easy_U16 port, char* streamName, int rtpOverTcp/*1-tcp, 2-udp*/, char *username, char *password, EASY_MEDIA_INFO_T*  pstruStreamInfo, Easy_U32 bufferKSize, Easy_Bool createlogfile );

	/* ֹͣ */
	Easy_API Easy_U32 Easy_APICALL EasyPusher_StopStream(Easy_Handle handle);

	/*  frame:͵ý֡ */
	Easy_API Easy_U32 Easy_APICALL EasyPusher_PushFrame(Easy_Handle handle, EASY_AV_Frame* frame );

#ifdef __cplusplus
}
#endif

#endif